%K=100; k=50; M=1; m=.1; c=.01; C=.01; %sistema cattivo%
K=1000; k=1; M=10; m=0.1; c=.01; C=.1; %sistema buono%

V=[M 0 0 0;0 1 0 0;m 0 m 0;0 0 0 1];
Aa=[-c -k C K;1 0 0 0;0 0 -C -K;0 0 1 0];
Bb=[1 0 0 0]';
A=inv(V)*Aa;
%numero di stati
n=size(A,1);
B=inv(V)*Bb;
Axx=A(1:2,1:2);
Axy=A(1:2,3:4);
Ayx=A(3:4,1:2);
Ayy=A(3:4,3:4);
Bx=B(1:2);
By=B(3:4);

C=eye(4);
D=[0 0 0 0]';

Crid=C(1:2,1:2);
Drid=[0 0]';

Ares=Axx-Axy*inv(Ayy)*Ayx;
Bres=Bx-Axy*inv(Ayy)*By;

Atru=Axx; %dinamiche lente
Btru=Bx; %dinamiche lente

[Tsch,Asch]=schur(A);
Bsch=Tsch'*B;
Csch=C*Tsch;

%scrivi Schur a due stati
Aschur=Asch(1:2,1:2)-Asch(1:2,3:4)*inv(Asch(3:4,3:4))*Asch(3:4,1:2);
Bschur=Bsch(1:2,:)-Asch(1:2,3:4)*inv(Asch(3:4,3:4))*Bsch(3:4,:); 
Cschur=Csch(1:2,1:2);
Dschur=Drid;

sys=ss(A,B,C,D);
systru=ss(Atru,Btru,Crid,Drid);
sysres=ss(Ares,Bres,Crid,Drid);
sysschur=ss(Aschur,Bschur,Cschur,Dschur)

fmax=max(abs(eig(A)))/2/pi;
fmin=min(abs(eig(A)))/2/pi;
dt=1/(round(fmax/10)*100);
tfin=10*ceil(1/fmin);
t=[0:dt:tfin];

y=step(sys,t);
ytru=step(systru,t);
yres=step(sysres,t);
yschur=step(sysschur,t);

figure(1)
plot(t,y(:,1),':',t,ytru(:,1),'-',t,yres(:,1),'-.',t,yschur(:,1),'--');
legend('vero','troncato','residualizzizzato','schur');
title('Velocita');
xlabel('tempo');
print -depsc2 velocita.eps;


figure(2)
plot(t,y(:,2),':',t,ytru(:,2),'-',t,yres(:,2),'-.',t,yschur(:,2),'--');
legend('vero','troncato','residualizzizzato','schur');
title('Spostamento');
xlabel('tempo');
print -depsc2 spostamento.eps;

